/*
    Copyright (C) 2012 Bartosz Broda, Jacek Bochenek, Łukasz Biłeńkij, 
    Damian Jaworski, Wojciech Mazur, Dominik Piasecki, Maciej Piasecki, 
    Radosław Ramocki
    
    This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.

    This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. 

    See the LICENSE and COPYING files for more details.
*/

#include "utils.h"


namespace Matrices
{

	void update_features(Matrices::SuperMatrixPtr pMatrix, bool update_tf)
	{
		update_row_features(pMatrix->GetCRS(), pMatrix->GetRowFeatures(), update_tf);
		update_column_features(pMatrix->GetCCS(), pMatrix->GetColumnFeatures() , update_tf);
	}

	void update_row_features(Matrices::CRSMatrixPtr pCRS,
							 Matrices::FeatureVectorPtr pFeatures,
							 bool update_tf
							 )
	{
		for(size_t row_no = 0; row_no < pCRS->NumberOfRows(); ++row_no)
		{
			Feature &f = (*pFeatures)[row_no];
			CompressedVectorPtr pVector = pCRS->GetCompressedRow(row_no);
			if(update_tf)
				f.SetTermFrequnecy( Measures::CountVectorSum(pVector) );
			f.SetNZ(pVector->GetValues()->size());
			f.SetEntropy(Measures::CountVectorEntropy(pVector));
		}

	}

	void update_column_features(Matrices::CCSMatrixPtr pCCS,
								Matrices::FeatureVectorPtr pFeatures,
								bool update_tf)
	{
		for(size_t column_no = 0; column_no < pCCS->NumberOfColumns(); ++column_no)
		{
			Feature &f = (*pFeatures)[column_no];
			CompressedVectorPtr pVector = pCCS->GetCompressedColumn(column_no);
			if(update_tf)
				f.SetTermFrequnecy( Measures::CountVectorSum(pVector) );
			f.SetNZ(pVector->GetValues()->size());
			f.SetEntropy(Measures::CountVectorEntropy(pVector));
		}
	}

}// ns Matrices
